#!/usr/local/bin/perl

#######################################
###Mosaic-like Effect with IE Filter###
###K.Tsuada 2003/5/4                ###
#######################################

require "./cgi-lib.pl";

####    Constants       ####
$DEFAULT_IMG = "http://mobiquitous.com/~tsuka/programming/ponyo.jpg";
$DEFAULT_STEP = 5;
$DEFAULT_SIZE =25;
$DEFAULT_INTERVAL = 2000;

####    Main Routine    ####
&get_query;
&print_html;
exit (0);

####    Sub Routine     ####
sub get_query{
	&ReadParse;
	$image = $in{"image"};
	if($image eq  ""){
	    $image=$DEFAULT_IMG;
	}
	$step = $in{"step"};
	if($step eq  ""){
	    $step=$DEFAULT_STEP;
	}
	$size = $in{"size"};
	if($size eq  ""){
	    $size=$DEFAULT_SIZE;
	}
	$interval = $in{"interval"};
	if($interval eq  ""){
	    $interval=$DEFAULT_INTERVAL;
	}
}

sub print_html{
	print "Content-type: text/html\n\n";
	print <<EOF;
	<html>
	<head>
	<title>Mosaic Animation Sample</title>
	</head>
	<body id = "body" bgcolor = "white" onload="changeFilter()">
	<script language = "javascript">
	var timerID
EOF

	print "var num=" . int($size / $step) . "\r\n";
	print "var counter=" . $size . "\r\n";

	print<<EOF;    
	function changeFilter(){
		if(counter < 1){
			div1.style.filter = "progid:DXImageTransform.Microsoft.Pixelate(enabled=false)"
			clearTimeout(timerID)
		   return
		}
	div1.style.filter = "progid:DXImageTransform.Microsoft.Pixelate(MaxSquare=" + counter + ")"
	counter = counter - num
EOF

	print  "timerID = setTimeout(\"changeFilter()\"," . $interval . ")";

	print <<EOF;
    }
</script>
EOF

	#print	"<img src =$image alt =image$i id=div1>\n";
	print	"<img src =$image alt =image id=div1 style=filter:progid:DXImageTransform.Microsoft.Pixelate(". $size .")>\n";	
	print "</body>\n";
}

####    End    ####
